#include <bits/stdc++.h>
//#include <fcntl.h>
 
using std::max; using std::swap; using std::abs; using std::priority_queue; using std::queue; using std::bitset; using std::make_tuple; 
using std::istream; using std::ostream; using std::fixed; using std::greater; using std::tuple; using std::tie; using std::make_pair;
using std::cout; using std::cerr; using std::endl; using std::lower_bound; using std::upper_bound; using std::deque; using std::min; 
using std::map; using std::string; using std::fill; using std::copy; using std::sort; using std::unique; using std::unordered_set; 
using std::multiset; using std::nth_element; using std::min_element; using std::max_element; using std::vector; using std::set; 
using std::unordered_map; using std::pair; using std::next_permutation; using std::reverse; using std::rotate; using std::cin; 
using std::iota; using std::function; using std::shuffle; using std::iter_swap; using std::ofstream; using std::ifstream;
 
typedef long long ll;
typedef long double ld;
typedef unsigned int uint;
typedef unsigned long long ull;
 
int const INF = 100 + (int) 1e9;
ll const INFL = 100 + (ll) 1e18;
ld const PI = 3.141592653589793238462643L;
std::mt19937 mt19937(960172);
 
ll rnd(ll x, ll y) { static auto gen = std::bind(std::uniform_int_distribution<ll>(), mt19937); return gen() % (y - x + 1) + x; }
bool is_prime(ll x) { if (x <= 1) return 0; for (ll y = 2; y * y <= x; ++y) if (x % y == 0) return 0; return 1; }
ll sqr(int a) { return (ll) a * a; } ld sqr(ld a) { return a * a; } ll sqr(ll a) { return a * a; }
ll gcd(ll a, ll b) { while (b > 0) { ll t = a % b; a = b; b = t; } return a; }
 
int const N = 222;
int const dx[] = {1, 0, -1, 0};
int const dy[] = {0, 1, 0, -1};
string dir = "DRUL";
 
char a[N][N], s[N];
int n, m, len;
 
bool inside(int x, int y) {
    return x >= 0 && x < n && y >= 0 && y < m;
}
 
int mcolor[N][N][N];
 
struct node {
    int i, j, pos;
    char from;
     
    int& color() {
        return mcolor[i][j][pos];
    }
     
    vector<node> moves() {
        int next_pos = pos + 1;
        if (next_pos == len)
            next_pos = 0;
        vector<node> ret;
        for (int d = 0; d < 4; ++d) {
            int x = i + dx[d];
            int y = j + dy[d];
            if (inside(x, y) && a[x][y] == s[next_pos]) {
                ret.push_back({x, y, next_pos, dir[d]});
            }
        }
        return ret;
    }
};
 
bool operator!=(node const& a, node const& b) {
    return a.i != b.i || a.j != b.j || a.pos != b.pos;
}
 
vector<node> st;
vector<node> ans;
 
bool dfs(node v) {
    v.color() = 1;
    st.push_back(v);
     
    auto g  = v.moves();
     
    for (auto to : g) {
        if (to.color() == 2)
            continue;
             
        if (!to.color()) {
            if (dfs(to))
                return true;
        } else {
            ans.push_back(to);
            while (st.back() != to) {
                ans.push_back(st.back());
                st.pop_back();
            }
            reverse(ans.begin(), ans.end());
            return true;
        }
    }
     
    v.color() = 2;
    st.pop_back();
    return false;
}
 
void solve() {
     
    cin >> n >> m >> len;
    for (int i = 0; i < n; ++i)
        cin >> a[i];
    cin >> s;
 
    static int pi[N];
    pi[0] = 0;
    for (int j = 0, i = 1; i < len; ++i) {
        while (j && s[j] != s[i])
            j = pi[j - 1];
        if (s[j] == s[i])
            ++j;
        pi[i] = j;
    }
     
    if (len % (len - pi[len - 1]) == 0) {
        len -= pi[len - 1];
    }
     
    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
         
            node start = {i, j, 0, 0};
             
            if (a[i][j] == s[0] && !start.color() && dfs(start)) {
                cout << "YES" << '\n';
                cout << ans.size() << '\n';
                 
                int st = 0;
                while (ans[st].pos != 0)
                    ++st;
                     
                ++st;
                if (st == (int)ans.size())
                    st = 0;
                     
                rotate(ans.begin(), ans.begin() + st, ans.end());
                 
                cout << ans.back().i + 1 << ' ' << ans.back().j + 1 << '\n';
                for (auto x : ans) {
                    cout << x.from;
                }
                cout << '\n';
                return;
            }
        }
    }
     
    cout << "NO" << '\n';
}
 
 
 
int main() {
     
    //freopen("", "r", stdin);
    //freopen("", "w", stdout);
     
    cout.precision(15);
    cout << fixed;
    cerr.precision(6);
    cerr << fixed;
     
    int tcn = 1;
    for (int tn = 1; tn <= tcn; ++tn)
        solve();
     
#ifdef LOCAL
    cerr << "time: " << (ll) clock() * 1000 / CLOCKS_PER_SEC << " ms" << endl;
#endif
}