#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int MAXN = 505, MAXL = 505;

char field[MAXN][MAXN];

string zip(string s) {
    vector<int> z(szof(s));

    int l = 0, r = 0;
    for (int i = 1; i < szof(s); ++i) {
        if (r > i) {
            z[i] = min(r - i, z[i - l]);
        }
        while (z[i] + i < szof(s) && s[z[i]] == s[i + z[i]]) {
            ++z[i];
        }

        if (z[i] + i == szof(s) && z[i] % i == 0) {
            s.resize(i);
            return s;
        }

        if (r < i + z[i]) {
            r = i + z[i];
            l = i;
        }
    }
    return s;
}

int main(int argc, char * argv[]) {
    registerTestlibCmd(argc, argv);
    
    string jans = ans.readToken();
    string pans = ouf.readToken();

    if (pans != "NO" && pans != "YES") {
        quitf(_wa, "participant printed %s instead of \"YES\" or \"NO\"", pans.c_str());
    }

    if (pans == "YES") {
        int n = inf.readInt();
        int m = inf.readInt();
        int l = inf.readInt();

        for (int i = 0; i < n; ++i) {
            string s = inf.readToken();
            for (int j = 0; j < m; ++j) {
                field[i][j] = s[j];
            }
        }
        string need = inf.readToken();
        
        int tot = ouf.readInt();
        if (tot <= 0) {
            quitf(_wa, "participant printed %d as length of sequence", tot);
        }

        string res;

        int x = ouf.readInt(1, n) - 1;
        int y = ouf.readInt(1, m) - 1;
        int memx = x;
        int memy = y;

        string seq = ouf.readToken();

        if (szof(seq) != tot) {
            quitf(_wa, "length of sequence isn't equal to %d", tot);
        }

        for (int i = 0; i < tot; ++i) {
            res += field[x][y];
            if (seq[i] == 'L') {
                --y;
            } else if (seq[i] == 'R') {
                ++y;
            } else if (seq[i] == 'U') {
                --x;
            } else if (seq[i] == 'D') {
                ++x;
            } else {
                quitf(_wa, "incorrect symbol on %d-th position", i + 1);
            }
            if (x < 0 || n <= x || y < 0 || m <= y) {
                quitf(_wa, "sequence leaves field on %d-th step", i + 1);
            }
        }

        if (x != memx || y != memy) {
            quitf(_wa, "sequence isn't cyclic");
        }

        if (zip(need) != zip(res)) {
            quitf(_wa, "participant's sequence doesn't generate required string");
        }

        if (jans == "YES") {
            quitf(_ok, "correct sequence");
        }
        quitf(_fail, "participant found sequence, but jury didn't");
    }
    
    if (jans == "YES") {
        quitf(_wa, "participant didn't find sequence");
    }

    quitf(_ok, "sequence doesn't exist");

    return 0;
}