#include "bits/stdc++.h"
#include "testlib.h"
#define puba push_back
#define mapa make_pair
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 200, MAXL = 200;

char field[MAXN][MAXN];

int main(int argc, char* argv[]) {
    registerGen(argc, argv, 1);

    assert(argc >= 3);

    int n = atoi(argv[1]);
    int m = atoi(argv[2]);

    assert(m % 4 == 3 && n >= 3);

    int tot = m + 2 + (n - 1) * (m / 2) + (n - 2);

    int l = 1;
    for (int i = 1; i <= MAXL; ++i) {
        if (tot % i == 0) {
            l = i;
        }
    }

    cout << n << " " << m << " " << l << endl;

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            field[i][j] = 'z';
        }
    }

    string s;
    for (int i = 0; i < l; ++i) {
        s += 'a' + rnd.next(0, 24);
    }

    int c = 0;
    for (int i = 0; i < m; ++i) {
        field[0][i] = s[c];
        c = (c + 1) % l;
    }

    field[1][m - 1] = s[c];
    c = (c + 1) % l;

    int d = 1;
    int x = 2, y = m - 1;

    while (y > 0) {
        while (true) {
            field[x][y] = s[c];
            c = (c + 1) % l;
            if (x + d == n || x + d == 1) {
                --y;
                field[x][y] = s[c];
                c = (c + 1) % l;
                --y;
                break;
            }
            x += d;
        }
        d *= -1;
    }

    while (x > 0) {
        field[x][y] = s[c];
        c = (c + 1) % l;
        --x;
    }

    rotate(s.begin(), s.begin() + rnd.next(0, l - 1), s.end());

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            cout << field[i][j];
        }
        cout << "\n";
    }

    cout << s << "\n";
    
    return 0;
}