#include "bits/stdc++.h"
#define puba push_back
#define ff first
#define ss second
#define bend(_x) begin(_x), end(_x)
#define szof(_x) ((int) (_x).size())
#define TASK_NAME ""

using namespace std;
typedef long long ll;
typedef pair<int, int> pii;
const int INF = 1e9 + 7;
const double PI = atan2(0, -1);
const int MAXN = 305, MAXL = 305;

int n, m, l;
char field[MAXN][MAXN];
char s[MAXL];
vector<vector<int>> graph;
vector<int> now;
vector<int> used;

int dfs(int v) {
    //cerr << v << endl;
    used[v] = 1;
    now.puba(v);
    for (int to: graph[v]) {
        if (!used[to]) {
            dfs(to);
        } else if (used[to] == 1) {
            reverse(bend(now));
            //cerr << szof(now) << endl;
            while (now.back() != to) {
                now.pop_back();
            }
            //cerr << szof(now) << endl;
            reverse(bend(now));
            int pos = -1;
            for (int i = 0; i < szof(now); ++i) {
                //cerr << now[i] % l << endl;
                if (now[i] % l == 0) {
                    pos = i;
                    break;
                }
            }
            assert(pos != -1);
            rotate(now.begin(), now.begin() + pos, now.end());
            cout << "YES\n" << szof(now) << "\n";
            int prevx = now[0] / l / m;
            int prevy = now[0] / l % m;
            cout << prevx + 1 << " " << prevy + 1 << "\n";
            

            now.puba(now[0]);
            for (int i = 1; i < szof(now); ++i) {
                int nx = now[i] / l / m;
                int ny = now[i] / l % m;
                if (nx < prevx) {
                    cout << "U";
                } else if (nx > prevx) {
                    cout << "D";
                } else if (ny < prevy) {
                    cout << "L";
                } else {
                    cout << "R";
                }
                prevx = nx;
                prevy = ny;
            }
            cout << "\n";
            exit(0);
        }
    }
    used[v] = 2;
    now.pop_back();
    return 0;
}

int dx[4] = {1, 0, -1, 0};
int dy[4] = {0, 1, 0, -1};

string zip(string s) {
    vector<int> z(szof(s));

    int lg = 0, rg = 0;
    for (int i = 1; i < szof(s); ++i) {
        if (rg > i) {
            z[i] = min(rg - i, z[i - lg]);
        }
        while (z[i] + i < szof(s) && s[z[i]] == s[i + z[i]]) {
            ++z[i];
        }

        if (z[i] + i == szof(s) && z[i] % i == 0) {
            s.resize(i);
            return s;
        }

        if (rg < i + z[i]) {
            rg = i + z[i];
            lg = i;
        }
    }
    return s;
}

int main() {
    //freopen(TASK_NAME ".in", "r", stdin);
    //freopen(TASK_NAME ".out", "w", stdout);

    scanf("%d%d%d", &n, &m, &l);

    for (int i = 0; i < n; ++i) {
        scanf("%s", field[i]);
    }

    scanf("%s", s);
    
    string tmp = zip(s);

    for (int i = 0; i < szof(tmp); ++i) {
        s[i] = tmp[i];
    }

    s[szof(tmp)] = 0;
    l = szof(tmp);

    int tot = n * m * l;
    graph.resize(tot);
    used.resize(tot);

    for (int i = 0; i < n; ++i) {
        for (int j = 0; j < m; ++j) {
            for (int k = 0; k < l; ++k) {
                if (field[i][j] != s[k]) {
                    continue;
                }
                int nk = (k + 1) % l;
                for (int d = 0; d < 4; ++d) {
                    int ni = i + dx[d];
                    int nj = j + dy[d];
                    if (0 <= ni && ni < n && 0 <= nj && nj < m && field[ni][nj] == s[nk]) {
                        graph[(i * m + j) * l + k].puba((ni *  m + nj) * l + nk);
                        //assert((i * m + j) * l + k < tot && (ni *  m + nj) * l + nk < tot);
                    }
                }
            }
        }
    }
    
   
    for (int i = 0; i < tot; ++i) {
        if (!used[i]) {
            dfs(i);
        }
    }

    cout << "NO\n";

    #ifdef LOCAL
        cerr << "time: " << clock() << endl;
    #endif
    return 0;
}