#include <iostream>
#include <vector>
#include <bitset>
#include <map>
#include <ctime>
#include <string>
#include <algorithm>
#include <queue>
#include <cstring>
#include <set>
#include <unordered_set>

using namespace std;

#define pii pair <int, int>
#define fraction float
const int N = 2e3;

fraction sum[N][N];
fraction arr[N];

inline bool cmp(const pii &a, const pii &b)
{
	return a.first * b.second < a.second * b.first;
}

inline bool cmp2(const pair <pii, int> &a, const pair <pii, int> &b)
{
	return cmp(a.first, b.first);
}

fraction rect[N][N];
pair <int, int> pref[N][N];
pair <int, int> pref2[N][N];
pair <pii, int> v[N];

int main()
{
	::ios_base::sync_with_stdio(false);
	cin.tie(0);
	cout.tie(0);
	int k;
	scanf("%d", &k);
	for (int i = 0; i < k; i++)
		scanf("%d%d", &v[i].first.first, &v[i].first.second),
		v[i].second = i;

	sort(v, v + k, cmp2);
	for (int i = 0; i < k; ++i)
	{
		arr[i] = v[i].first.first;
		arr[i] /= v[i].first.second;
	}
	float ans = -1e9;

	for (int a = 0; a < k; a++)
		for (int b = a; b < k; b++)
		{
			if (a == b)
				rect[a][b] = -1e9;
			else
			{
				rect[a][b] = v[a].first.first + v[b].first.first;
				rect[a][b] /= v[a].first.second + v[b].first.second;
			}
			pref[a][b] = { a, b };
			pref2[a][b] = { a, b };
		}
	for (int i = 0; i < k; i++)
	{
		if (i != 0)
			pref[i][i] = pref[i - 1][i];
		for (int j = i + 1; j < k; j++)
		{
			if (i > 0)
			{
				int id1 = pref[i][j].first;
				int id2 = pref[i][j].second;
				int id3 = pref[i - 1][j].first;
				int id4 = pref[i - 1][j].second;
				if (rect[id1][id2] < rect[id3][id4])
					pref[i][j] = { id3, id4 };
				id1 = pref2[i][j].first;
				id2 = pref2[i][j].second;
				id3 = pref2[i - 1][j].first;
				id4 = pref2[i - 1][j].second;
				if (rect[id1][id2] < rect[id3][id4])
					pref2[i][j] = { id3, id4 };
			}
			if (j > i + 1)
			{
				int id1 = pref[i][j].first;
				int id2 = pref[i][j].second;
				int id3 = pref[i][j - 1].first;
				int id4 = pref[i][j - 1].second;
				if (rect[id1][id2] < rect[id3][id4])
					pref[i][j] = { id3, id4 };
			}
		}
	}
	vector <int> answer;
	for (int i = 1; i < k; i++)
	{
		int id1 = pref[i - 1][i - 1].first;
		int id2 = pref[i - 1][i - 1].second;
		float cur = rect[id1][id2];
		for (int j = i + 1; j < k; j++)
		{
			if (0 < cur)
				if (ans < cur - rect[i][j])
				{
					ans = cur - rect[i][j];
					answer = { v[id1].second, v[i].second, v[id2].second, v[j].second };
				}
			int id3 = pref2[i - 1][j].first;
			int id4 = pref2[i - 1][j].second;
			if (cur < rect[id3][id4])
			{
				cur = rect[id3][id4];
				id1 = id3;
				id2 = id4;
			}
		}
	}
	for (int i = 0; i < 4; ++i)
		cout << answer[i] + 1 << " ";
	//cout << ans << endl;

	return 0;
}
