#include <iostream>
using namespace std;

const int N = 5000;
int lcs[N + 1][N + 1];
int d[N + 1];

int main() {
    ios_base::sync_with_stdio(false); cin.tie(0);
    int n;
    string s, t;
    cin >> n >> s >> t;
    for (int i = 1; i <= n; i++)
        for (int j = 1; j <= n; j++)
            if (s[i - 1] == t[j - 1])
                lcs[i][j] = lcs[i - 1][j - 1] + 1;

    d[0] = true;
    for (int i = 1; i <= n; i++)
        for (int j = 0; j < i; j++)
            d[i] |= d[j] && lcs[i][n - j] >= i - j;

    puts(d[n] ? "Yes" : "No");
    return 0;
}